    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2006, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------------
    028     * PieURLGenerator.java
    029     * --------------------
    030     * (C) Copyright 2002-2006, by Richard Atkinson and Contributors.
    031     *
    032     * Original Author:  Richard Atkinson;
    033     * Contributors:     David Gilbert (for Object Refinery Limited);
    034     *
    035     * $Id: PieURLGenerator.java,v 1.3.2.2 2006/11/24 10:47:27 mungady Exp $
    036     *
    037     * Changes:
    038     * --------
    039     * 05-Aug-2002 : Version 1, contributed by Richard Atkinson;
    040     * 09-Oct-2002 : Fixed errors reported by Checkstyle (DG);
    041     * 07-Mar-2003 : Modified to use KeyedValuesDataset and added pieIndex
    042     *               parameter (DG);
    043     * 24-Apr-2003 : Switched around PieDataset and KeyedValuesDataset (DG);
    044     * ------------- JFREECHART 1.0.x ---------------------------------------------
    045     * 24-Nov-2006 : Updated API docs (DG);
    046     *
    047     */
    048    package org.jfree.chart.urls;
    049
    050    import org.jfree.data.general.PieDataset;
    051
    052    /**
    053     * Interface for a URL generator for plots that use data from a
    054     * {@link PieDataset}.
    055     * <P>
    056     * Classes that implement this interface should be either (a) immutable, or
    057     * (b) cloneable via the <code>PublicCloneable</code> interface (defined in
    058     * the JCommon class library).  This provides a mechanism for the referring
    059     * plot to clone the generator if necessary.
    060     */
    061    public interface PieURLGenerator {
    062
    063        /**
    064         * Generates a URL for one item in a {@link PieDataset}. As a guideline,
    065         * the URL should be valid within the context of an XHTML 1.0 document.
    066         *
    067         * @param dataset  the dataset (<code>null</code> not permitted).
    068         * @param key  the item key (<code>null</code> not permitted).
    069         * @param pieIndex  the pie index (differentiates between pies in a
    070         *                  'multi' pie chart).
    071         *
    072         * @return A string containing the URL.
    073         */
    074        public String generateURL(PieDataset dataset, Comparable key, int pieIndex);
    075
    076    }